MODULE gaux.

%% Auxiliary operations 

det X Y X1 Y1 X2 Y2 R:-
 R is (((X1 * Y2) - (X2 * Y1)) - ((X * Y2) - (X2 * Y))) + 
      ((X * Y1) - (X1 * Y)).

dist X Y X1 Y1 R :-
 R is ((X - X1) * (X - X1)) + ((Y - Y1) * (Y - Y1)).  

between X Y X1 Y1 X2 Y2:-
 dist X  Y  X1 Y1 D1,
 dist X  Y  X2 Y2 D2,
 dist X1 Y1 X2 Y2 D3,
 D1 =< D3,
 D2 =< D3. 

isinP    X Y X1 Y1 X2 Y2:-
 det     X Y X1 Y1 X2 Y2 0,
 between X Y X1 Y1 X2 Y2. 
   
isin   X Y X1 Y1 X2 Y2 X3 Y3 :-
 isinP X Y X1 Y1 X3 Y3.

isin   X Y X1 Y1 X2 Y2 X3 Y3 :-
 isinP X Y X1 Y1 X2 Y2.
 
isin   X Y X1 Y1 X2 Y2 X3 Y3 :-
 isinP X Y X3 Y3 X2 Y2.
     
isin   X Y X1 Y1 X2 Y2 X3 Y3:-
  det  X Y X1 Y1 X2 Y2 R1,
  R1 > 0,
  det  X Y X2 Y2 X3 Y3 R2,
  R2 > 0,
  det  X Y X3 Y3 X1 Y1 R3,
  R3 > 0.

member X (X::L).

member X (Y::L):- 
  member X L.

