MODULE gclass.
      
class point ((coord,(0,0))::nil) nil.

meth mv Self (Dx,Dy) NewS (
    get Self coord (X,Y),
    X1 is X + Dx,
    Y1 is Y + Dy,
    update Self coord (X1,Y1) NewS
).
              
class triangle St Mts:-
  St=((p,nil)::(q,nil)::(r,nil)::(eps,0)::(lx,nil)::nil),
  Mts=(in::writeTrg::writeLx::nil).
  
pred in Self InP (
 get Self p P,
 get P coord (X1,Y1),
 get Self q Q,
 get Q coord (X2,Y2),
 get Self r R,
 get R coord (X3,Y3), 
 get InP coord (X,Y),
 isin X Y X1 Y1 X2 Y2 X3 Y3           
).

pred writeTrg Self nil (
 get Self p P,
 get P coord C1,
 get Self q Q,
 get Q coord C2,
 get Self r R,
 get R coord C3, 
 get Self eps Eps,
 writeTrg C1 C2 C3 Eps
).

pred writeLx Self nil (
 get Self lx Lx,
 writeTrgList Lx
).
 
writeTrg (X1,Y1) (X2,Y2) (X3,Y3) Eps:-
 nl,write_sans("Precision: "),write(Eps),nl,
 write_sans("     "),
 write(X3),write_sans(","),write(Y3),nl,
 write_sans("    /    \"),nl,
 write(X1),write_sans(","),write(Y1),
 write_sans(" ----- "),
 write(X2),write_sans(","),write(Y2),nl,nl.

writeTrgList nil.

writeTrgList (T::Ts):-
 call T writeTrg nil,
 writeTrgList Ts.

new_point Q:-
 write_sans("Insert X:"),
 read(X),
 write_sans("Insert Y:"),
 read(Y),
 new point P ,
 initPt (X,Y) P Q.

readVertex P Q R Eps:-
 write_sans("Epsilon:"),
 read(Eps),
 new_point P,
 new_point Q,
 new_point R.

initTrg P Q R Eps Lx (St1,Mts) (St,Mts):-
 St1 = ((p,P1)::(q,Q1)::(r,R1)::(eps,Eps1)::(lx,Lx1)::Stx),
 St  = ((p,P) ::(q,Q) ::(r,R) ::(eps,Eps) ::(lx,Lx) ::Stx).

initPt C (St1,Mts) (St,Mts):-
 St1 = ((coord,C1)::Stx),
 St  = ((coord,C)::Stx).

build_triangulation NT:-
 readVertex P Q R Eps,
 write_sans("Quanti sotto triangoli?"),
 read(N),
 build_triangle_list N Lx,
 new triangle T, 
 initTrg P Q R Eps Lx T NT. 

build_triangle_list N (T::Ts):-
 N>0,
 build_triangulation T,
 N1 is N-1,  
 build_triangle_list N1 Ts. 

build_triangle_list 0 nil.

